/*
 * post_raw.h
 * Main header file for libpost_raw
 * listpostal project
 * libpost_raw library
 * $Id: post_raw.h,v 1.2 2001/01/08 08:07:04 fullermd Exp $
 */


/* Header files including header files.  Bad monkey! */
#include <sys/types.h>
#include <netinet/in.h>


/* Typedef */
typedef struct postal_conn POSTAL_CONN;
typedef struct spec_pop SPEC_POP;
typedef struct pop_ret_stat POP_RET_STAT;
typedef struct pop_ret_list POP_RET_LIST;
typedef struct pop_ret_list_item POP_RET_LIST_ITEM;


/* Function prototypes */
/* POP */
int pop_close(POSTAL_CONN *);
POSTAL_CONN *pop_connect(const char *, const char *, const char *);
void pop_free_retlist(POP_RET_LIST *);
POP_RET_LIST *pop_list(POSTAL_CONN *);
int pop_login(POSTAL_CONN *, const char *, const char *);
POSTAL_CONN *pop_network_connect(struct sockaddr_in);
POP_RET_STAT *pop_stat(POSTAL_CONN *);


/* Macros */
#define PCONN_SIZE		(sizeof(POSTAL_CONN))
#define SPOP_SIZE		(sizeof(SPEC_POP))
#define PRSTAT_SIZE		(sizeof(POP_RET_STAT))
#define PRLIST_SIZE		(sizeof(POP_RET_LIST))
#define PRLITEM_SIZE	(sizeof(POP_RET_LIST_ITEM))


/* Structures */
/* postal_conn: A single libpost_raw connection */
struct postal_conn
{
	int				sock;
	union
	{
		SPEC_POP	*pop;
	} specinfo;
};


/* spec_pop: Special info for POP connections */
struct spec_pop
{
	char *srv_header;			/* Server greeting header */
};


/* pop_ret_stat: Information return from POP STAT query */
struct pop_ret_stat
{
	unsigned int num_msg;
	unsigned long num_bytes;
};


/* pop_ret_list: Information return from POP LIST query */
struct pop_ret_list
{
	POP_RET_STAT *stat_info;
	POP_RET_LIST_ITEM *list_head;
};

/* pop_ret_list_item: Individual 'list' message */
struct pop_ret_list_item
{
	unsigned int msg_num;
	unsigned long msg_size;
	POP_RET_LIST_ITEM *next;
};
