/*
 * pop_close.c
 * Close down a POP connection
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_close.c,v 1.2 2001/01/08 08:07:04 fullermd Exp $
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/uio.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


int
pop_close(POSTAL_CONN *to_close)
{
	char buf[BUFFER_SIZE];

	/* Send the 'quit' command */
	sprintf(buf, "QUIT\r\n");
	POP_CMD_SEND(to_close, buf);
	CLEARSTRING(buf);

	/* Check the response */
	if( pop_answer_check(to_close) > 0 )
		return 1;	/* Bad close attempt; no known reason */

	/* Call the backend, and free the structure */
	pop_network_close(to_close);

	return(0);
}
