/*
 * pop_network_connect.c
 * Do the TCP/IP connection to the POP server
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_network_connect.c,v 1.2 2001/01/08 08:07:04 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>

#include <post_raw.h>
#include <post_raw_pop_p.h>


POSTAL_CONN *
pop_network_connect(struct sockaddr_in server)
{
	POSTAL_CONN *new_connect;
	char *in_hdr;
	char in_hdr_tmp[POP_HDRLEN];

	/* Get our memory ready */
	new_connect = malloc(PCONN_SIZE);
	new_connect->specinfo.pop = malloc(SPOP_SIZE);

	/* Start our connecting... */
	new_connect->sock = socket(AF_INET, SOCK_STREAM, 0);
	if( connect(new_connect->sock, (struct sockaddr *) &server,
			sizeof(server)) < 0 ) 
	{
		return(NULL);
	}

	/* Read in the header from the POP server */
	read(new_connect->sock, in_hdr_tmp, POP_HDRLEN);

	/* Connect up and send on back */
	in_hdr = malloc( strlen(in_hdr_tmp)+1 );
	strcpy(in_hdr, in_hdr_tmp);
	new_connect->specinfo.pop->srv_header = in_hdr;

	return(new_connect);
}
