/*
 * pop_stat.c
 * POP 'STAT' query
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_stat.c,v 1.2 2001/01/08 08:07:04 fullermd Exp $
 */

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/uio.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


POP_RET_STAT *
pop_stat(POSTAL_CONN *p_conn)
{
	char buf[BUFFER_SIZE];
	char *buf2;
	unsigned long numbytes;
	unsigned int nummsg;
	POP_RET_STAT *toret;

	/* Send request */
	sprintf(buf, "STAT\r\n");
	POP_CMD_SEND(p_conn, buf);
	CLEARSTRING(buf);

	/* Get the response */
	read(p_conn->sock, buf, BUFFER_SIZE);

	/*
	 * Interpret the response.
	 * Basically, there are 3 parts to a STAT response.
	 * +OK <num_messages> <num_bytes>
	 */

	/* First, check that we have a good response, else bail */
	if( (strncmp(buf, POP_GOOD, strlen(POP_GOOD)) != 0) )
		return(NULL);

	/*
	 * Now, lets split it out.
	 * First, the number of octets.
	 */
	buf2 = strrchr(buf, (int) ' ');
	numbytes = strtoul(buf2, (char **)NULL, 10);

	/* And the number of messages */
	*buf2 = '\0';
	buf2 = strrchr(buf, (int) ' ');
	nummsg = atoi(buf2);

	/* Build out the structure */
	toret = malloc(PRSTAT_SIZE);
	toret->num_msg = nummsg;
	toret->num_bytes = numbytes;

	return(toret);
}
